<?php

/**
 * Register password migrator Part I
 *
 * @version     1.1
 * @copyright   (c) 2012, Christoph M. Becker
 * @license     http://www.gnu.org/licenses/gpl.html  GPLv3
 */


/**
 * Returns the stored password of $user, if the user exists; otherwise returns null.
 *
 * @param  string $user
 * @return string
 */
function Register_password($user)
{
    global $pth, $plugin_tx;
    
    $fn = $pth['folder']['base'] . $plugin_tx['register']['config_usersfile'];
    
    $lines = file($fn);
    foreach ($lines as $line) {
        $line = rtrim($line);
        if (!empty($line) && strpos($line, '//') !== 0) {
            $rec = explode(':', $line);
            if ($rec[0] == $user) {
                return $rec[1];
            }
        }        
    }
    return null;
}


/**
 * Returns the logged new passwords.
 *
 * @return array  user=>password
 */
function Register_passwords()
{
    global $pth, $plugin_tx;
    
    $fn = $pth['folder']['base'] . $plugin_tx['register']['config_usersfile'] . '.mig';
    $passes = array();
    $lines = file($fn);
    foreach ($lines as $line) {
        $line = rtrim($line);
        $rec = explode("\t", $line);
        $passes[$rec[0]] = $rec[1];
    }
    return $passes;
}


/**
 * Returns the list of users.
 *
 * @return array
 */
function Register_users()
{
    global $pth, $plugin_tx;
    
    $fn = $pth['folder']['base'] . $plugin_tx['register']['config_usersfile'];
    $users = array();
    $lines = file($fn);
    foreach ($lines as $line) {
        $line = rtrim($line);
        if (!empty($line) && strpos($line, '//') !== 0) {
            $rec = explode(':', $line);
            $users[] = $rec;
        }        
    }
    return $users;
}


/**
 * Logs the username and hashed password.
 *
 * @return void
 */
function Register_logPasswords()
{
    global $pth, $sl, $plugin_tx;
    
    include $pth['folder']['plugins'] . 'register/languages/' . $sl . '.php';
    
    $user = stsl($_POST['username']);
    $pass = stsl($_POST['password']);
    
    if (crypt($pass, $pass) === Register_password($user)) {
        if (!class_exists('PasswordHash')) {
            include $pth['folder']['cmsimple'] . 'PasswordHash.php';
        }
        $hasher = new PasswordHash(8, true);
        $pass = $hasher->HashPassword($pass);
        $line = "$user\t$pass\n";
    
        $fn = $pth['folder']['base'] . $plugin_tx['register']['config_usersfile'] . '.mig';
        $fh = fopen($fn, 'ab');
        fwrite($fh, $line);
        fclose($fh);
    }
}


/**
 * Returns the ratio of gathered passwords.
 *
 * @return string  The(X)HTML.
 */
function Register_checkPasswords()
{
    global $pth, $sl, $plugin_tx;
    
    include $pth['folder']['plugins'] . 'register/languages/' . $sl . '.php';
    $users = Register_users();
    $passes = Register_passwords();
    $count = 0;
    foreach ($users as $user) {
        if (array_key_exists($user[0], $passes)) {
            $count++;
        }
    }
    return '<div class="cmsimplecore_warning">' . $count . ' of '
        . count($users) . ' passwords gathered.</div>';
}


/*
 * Hook in on registerlogin resp. handle registercheckpasswords.
 */
if ($function == 'registerlogin') {
    Register_logPasswords();
} elseif ($function == 'registercheckpasswords') {
    $o .= Register_checkPasswords();
}
